
#include <avr/io.h>

//! Macro that SUPPOSEDLY SHOULD SET all Timer/counter0 interrupt flags (but it doesn't)
#define SET_ALL_TIMER0_INT_FLAGS_BAD_TRY_1  (TIFR0=0x00)
#define SET_ALL_TIMER0_INT_FLAGS_BAD_TRY_2  (TIFR0=(0<<OCF0B)|(0<<OCF0A)|(0<<TOV0))
#define SET_ALL_TIMER0_INT_FLAGS_BAD_TRY_3  (TIFR0&=~(1<<OCF0B)|(1<<OCF0A)|(1<<TOV0))

//! Macro that CLEARS all Timer/counter0 interrupt flags.
#define CLEAR_ALL_TIMER0_INT_FLAGS_WAY_1  (TIFR0=TIFR0)
//is cleared by writing a logic one to the flag (right way)
#define CLEAR_ALL_TIMER0_INT_FLAGS_WAY_2  (TIFR0=(1<<OCF0B)|(1<<OCF0A)|(1<<TOV0))
#define CLEAR_ALL_TIMER0_INT_FLAGS_WAY_3  (TIFR0|=(1<<OCF0B)|(1<<OCF0A)|(1<<TOV0))
#define CLEAR_ALL_TIMER0_INT_FLAGS_WAY_4  (TIFR0=0xFF)

#define CLEAR_OCF0B_TIMER0_INT_FLAG_TRY_1 (TIFR0|=(1<<OCF0B))
#define CLEAR_OCF0B_TIMER0_INT_FLAG_TRY_2 (TIFR0=(1<<OCF0B))

int main (void)
{
SET_ALL_TIMER0_INT_FLAGS_BAD_TRY_1;//(TIFR0=0x00), no effect
SET_ALL_TIMER0_INT_FLAGS_BAD_TRY_2;//(TIFR0=(0<<OCF0B)|(0<<OCF0A)|(0<<TOV0)), no effect
SET_ALL_TIMER0_INT_FLAGS_BAD_TRY_3;//(TIFR0&=~(1<<OCF0B)|(1<<OCF0A)|(1<<TOV0)), no effect

CLEAR_ALL_TIMER0_INT_FLAGS_WAY_1;//(TIFR0=TIFR0), for perverts, but it works!!!
CLEAR_ALL_TIMER0_INT_FLAGS_WAY_2;//(TIFR0=(1<<OCF0B)|(1<<OCF0A)|(1<<TOV0)), ok (right way)
CLEAR_ALL_TIMER0_INT_FLAGS_WAY_3;//(TIFR0|=(1<<OCF0B)|(1<<OCF0A)|(1<<TOV0)),  
CLEAR_ALL_TIMER0_INT_FLAGS_WAY_4;//(TIFR0=0xFF),  (right way)

CLEAR_OCF0B_TIMER0_INT_FLAG_TRY_1;//(TIFR0|=(1<<OCF0B)), ok
CLEAR_OCF0B_TIMER0_INT_FLAG_TRY_2;//(TIFR0=(1<<OCF0B)), ok
CLEAR_OCF0B_TIMER0_INT_FLAG_TRY_2;
while(1)
{
                            
}
}



